package com.megacz.eltron;

import org.ibex.util.*;
import org.ibex.graphics.*;
import java.io.*;
import java.util.*;
import gnu.io.*;

/** code to control an Eltron */
public class Eltron {

    public static void main(String[] s) throws Exception {
        Picture p = new Picture(System.in);
        print(p.data, p.width, p.height);
    }

    public static SerialPort detectPort() throws Exception {
        Enumeration e = CommPortIdentifier.getPortIdentifiers();
        while(e.hasMoreElements()) {
            CommPortIdentifier cpi = (CommPortIdentifier)e.nextElement();
            Log.info(Eltron.class, "detected " + cpi.getName());
            if (cpi.getName().indexOf("usbserial")!=-1) {
                SerialPort ret = new RXTXPort(cpi.getName());
                Log.info(Eltron.class, "returning " + ret);
                return ret;
            }
        }
        SerialPort ret = new RXTXPort("/dev/ttyS0");
        Log.info(Eltron.class, "returning " + ret);
        return ret;
    }

    public static void print(int[] data, int width, int height) throws Exception {
        SerialPort sp = detectPort();

        // you'll need to run this once at 9600 to tell the built-in eeprom to switch to 38,400kbps
        //sp.setSerialPortParams(9600, SerialPort.DATABITS_8, SerialPort.STOPBITS_1, SerialPort.PARITY_NONE);
        sp.setSerialPortParams(38400, SerialPort.DATABITS_8, SerialPort.STOPBITS_1, SerialPort.PARITY_NONE);

        OutputStream out = sp.getOutputStream();
        InputStream in = sp.getInputStream();
        int count = 0;
        PrintWriter pw = new PrintWriter(new OutputStreamWriter(out));
        pw.println();
        pw.flush();

        // uncomment this code the first time you run it (at 9600bps)
	/*
	System.out.println("rebooting device...");
        pw.println("^@");
        pw.println("^@");
        pw.println("^@");
        pw.flush();
	System.out.println("rebooted.");
        try { Thread.sleep(3000); } catch (Exception e) { }
	System.out.println("setting comm parameters...");
        pw.println();
        pw.flush();
        pw.println();
        pw.println("Y38,N,8,1");
        pw.flush();
	System.out.println("set.");
        try { Thread.sleep(2000); } catch (Exception e) { }
	System.exit(0);
	*/

        pw.println("^@");
        pw.println("^@");
        pw.println("^@");
        pw.flush();
        try { Thread.sleep(2000); } catch (Exception e) { }

        pw.println("OD");
        pw.println("N");
        pw.println("D14");
        pw.println("S1");
        pw.println("q780");

        int MAXWIDTH = 200 * 5 - 10;
        int MAXHEIGHT = 200 * 7 - 10;
        int owidth = ((int)Math.floor(Math.min(MAXWIDTH, height)/8.0)) * 8;   // FIXME: should be ceil
        int oheight = Math.min(MAXHEIGHT, width);
        int[] data2 = new int[owidth * oheight];
        for(int y=0; y<owidth; y++)
            for(int x=0; x<oheight; x++)
                data2[y+x*owidth] = data[x+(owidth-y-1)*width];
        data = data2;

        for(int y=0; y<oheight; y++) {
            pw.println("GW0,"+y+","+owidth/8+",1");
            pw.flush();
            DataOutputStream dout = new DataOutputStream(out);
            System.out.println("y="+y);
            for(int x=0; x<owidth; x+=8) {
                byte b = 0;
                for(int i=0; i<Math.min(8, owidth-x); i++) {
                    int dat = data[y*owidth+x+i];
                    dat &= 0x00ffffff;
                    if (dat==0) continue;
                    b |= 1 << (7-i);
                }
                dout.writeByte(b);
            }
            dout.flush();
            pw.println();
        }
        pw.println();
        pw.println();
        pw.println();
        pw.flush();

        pw.println("P1");
        pw.flush();
    }

}
